﻿import mx.utils.Delegate;
import mx.controls.Button;
import mx.controls.TextArea;
import mx.controls.TextInput;
import mx.controls.Alert;
class Livre {
	private var scene:MovieClip;
	private var action_btn:MovieClip;
	private var pageAct:Number;
	private var pageTot:Number;
	private var loadLivre:LoadVars;
	private var styleCSS:Object;
	private var styleCharge:Boolean;
	private var envoiMess:LoadVars;
	private static var NBPAGE:Number = 10;
	public function Livre(scen:MovieClip) {
		scene = scen;
		pageAct = 0;
		styleCharge = false;
		creerElementFixe();
		traceVoir();
	}
	private function creerElementFixe(Void):Void {
		// Création du fond de couleur gris
		scene.createEmptyMovieClip("fondGris", 1);
		var fondGris:MovieClip = eval(scene+".fondGris");
		var cl:String = "A0A0A0";
		with (fondGris) {
			moveTo(0, 0);
			lineStyle(0, "0x"+cl, 100);
			beginFill("0x"+cl, 100);
			lineTo(500, 0);
			lineTo(500, 400);
			lineTo(0, 400);
			endFill();
		}
		// Création du bouton de choix d'action
		var initObj:Object = new Object();
		initObj._x = 425;
		initObj._y = 10;
		initObj._width = 70;
		initObj.label = "Ajouter";
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, actionBout);
		scene.createClassObject(Button, "action_btn", 2, initObj);
		action_btn = eval(scene+".action_btn");
	}
	private function actionBout(Void):Void {
		if (action_btn.label == "Retour") {
			traceVoir();
			action_btn.label = "Ajouter";
		} else {
			traceAjouter();
			action_btn.label = "Retour";
		}
	}
	private function traceVoir(Void):Void {
		// Suppression de l'objet ajouter
		removeMovieClip(scene.ajouter);
		// Création du clip contenant tous nos objets à affichés
		scene.createEmptyMovieClip("livre", 3);
		// Création du TextArea pour afficher les messages
		var initObj:Object = new Object();
		initObj._x = 10;
		initObj._y = 10;
		initObj._width = 410;
		initObj._height = 380;
		initObj.editable = false;
		initObj.wordwrap = true;
		initObj.html = true;
		scene.livre.createClassObject(TextArea, "affichage_txt", 3, initObj);
		// Création du bouton Suivant
		var initObj:Object = new Object();
		initObj._x = 425;
		initObj._y = 330;
		initObj._width = 70;
		initObj.label = "Suivant";
		initObj._visible = false;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, suivant);
		scene.livre.createClassObject(Button, "suivant_btn", 4, initObj);
		initObj._y = 360;
		initObj._width = 70;
		initObj.label = "Précédent";
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Livre, via Delegate.create
		initObj.onRelease = Delegate.create(this, precedent);
		scene.livre.createClassObject(Button, "precedent_btn", 5, initObj);
		// création de l'objet de load du CSS
		if (styleCharge) {
			// On a deja chargé la CSS, on va cherché maintenant le texte
			chargeLivre();
		} else {
			scene.livre.affichage_txt.text = "Chargement de la CSS...";
			styleCSS = new TextField.StyleSheet();
			// Ici on dit que notre onLoad sera la fonction loadCSS
			//		de notre objet Livre, via Delegate.create
			styleCSS.onLoad = Delegate.create(this, loadCSS);
			styleCSS.load("livrestyle.css");
		}
	}
	private function loadCSS(success:Boolean) {
		if (success) {
			styleCharge = true;
			scene.livre.affichage_txt.text = "Chargement du Livre d'or...";
			chargeLivre();
		} else {
			scene.livre.affichage_txt.text = "Erreur de Chargement de la CSS...";
		}
	}
	private function chargeLivre(Void):Void {
		// On applique la CSS
		scene.livre.affichage_txt.styleSheet = styleCSS;
		loadLivre = new LoadVars();
		// Ici on dit que notre onLoad sera la fonction affLivre
		//		de notre objet Livre, via Delegate.create
		loadLivre.onLoad = Delegate.create(this, affLivre);
		loadLivre.page = pageAct;
		loadLivre.nbpage = NBPAGE;
		loadLivre.sendAndLoad("livre.php", loadLivre, "POST");
	}
	private function affLivre(succes:Boolean):Void {
		if (succes) {
			var monLivre:XML = new XML(loadLivre.retour);
			monLivre.ignoreWhite = true;
			pageTot = monLivre.firstChild.attributes.tot;
			if (monLivre.firstChild.attributes.tot>(pageAct+1)*NBPAGE) {
				scene.livre.suivant_btn._visible = true;
			} else {
				scene.livre.suivant_btn._visible = false;
			}
			if (pageAct>0) {
				scene.livre.precedent_btn._visible = true;
			} else {
				scene.livre.precedent_btn._visible = false;
			}
			var mesMessages:Array = monLivre.firstChild.childNodes;
			var affiche:String = "<span class=\"tout\">";
			for (var i = 0; i<mesMessages.length; i++) {
				affiche += "<span class=\"titre\">"+mesMessages[i].attributes.titre+"</span>";
				affiche += " par <a href=\"mailto:"+mesMessages[i].attributes.mail+"\">";
				affiche += mesMessages[i].attributes.de+"</a>";
				affiche += " le "+mesMessages[i].attributes.date+"<br>";
				affiche += mesMessages[i].firstChild.nodeValue;
				affiche += "<br><span class=\"barre\">------------------------------------------------------------------</span><br>";
			}
			affiche += "</span>";
			scene.livre.affichage_txt.text = affiche;
		} else {
			scene.livre.affichage_txt.text = "Erreur de chargement des messages du livre d'or";
		}
	}
	private function suivant(Void):Void {
		if (pageAct<pageTot) {
			pageAct++;
			chargeLivre();
		}
	}
	private function precedent(Void):Void {
		if (pageAct>0) {
			pageAct--;
			chargeLivre();
		}
	}
	private function traceAjouter(Void):Void {
		// Suppression de l'objet Livre
		removeMovieClip(scene.livre);
		// Création du clip contenant tous nos objets à affichés
		scene.createEmptyMovieClip("ajouter", 3);
		// Création des case à remplir
		var initObj:Object = new Object();
		// constant pour tous
		initObj._x = 10;
		initObj._width = 250;
		initObj._height = 22;
		// le titre
		initObj._y = 10;
		initObj.tabIndex = 1;
		scene.ajouter.createClassObject(TextInput, "titre", 4, initObj);
		scene.ajouter.createTextField("titre_txt", 5, initObj._x+initObj._width, initObj._y, 100, initObj._height);
		scene.ajouter.titre_txt.selectable = false;
		scene.ajouter.titre_txt.text = ": Titre";
		// le pseudo
		initObj._y += 30;
		initObj.tabIndex++;
		scene.ajouter.createClassObject(TextInput, "pseudo", 6, initObj);
		scene.ajouter.createTextField("pseudo_txt", 7, initObj._x+initObj._width, initObj._y, 100, initObj._height);
		scene.ajouter.pseudo_txt.selectable = false;
		scene.ajouter.pseudo_txt.text = ": Pseudo";
		// le mail
		initObj._y += 30;
		initObj.tabIndex++;
		scene.ajouter.createClassObject(TextInput, "mail", 8, initObj);
		scene.ajouter.createTextField("mail_txt", 9, initObj._x+initObj._width, initObj._y, 100, initObj._height);
		scene.ajouter.mail_txt.selectable = false;
		scene.ajouter.mail_txt.text = ": Mail";
		// Création du TextArea pour le message
		initObj._y += 30;
		initObj.tabIndex++;
		initObj._width = 480;
		initObj._height = 290;
		scene.ajouter.createClassObject(TextArea, "msg", 10, initObj);
		// Bouton ajouter
		initObj._x = 425;
		initObj._y -= 30;
		initObj.tabIndex++;
		initObj._width = 70;
		initObj._height = 22;
		initObj.label = "Ajouter";
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, ajouter);
		scene.ajouter.createClassObject(Button, "ajouter_btn", 11, initObj);
	}
	private function ajouter(Void):Void {
		var erreur:Array = new Array();
		if (scene.ajouter.titre.text.length<5) {
			erreur.push("Le titre est trop petit.");
		}
		if (scene.ajouter.pseudo.text.length<3) {
			erreur.push("Le pseudo est trop petit.");
		}
		if (scene.ajouter.mail.text.length<10) {
			erreur.push("Le mail est trop petit.");
		} else if (scene.ajouter.mail.text.indexOf("@") == -1 || scene.ajouter.mail.text.indexOf(".") == -1) {
			erreur.push("Le mail est invalide.");
		}
		if (scene.ajouter.msg.text.length<20) {
			erreur.push("Le message est trop petit.");
		}
		if (erreur.length>0) {
			// Il y a au moins 1 erreur
			Alert.show(erreur.join("\n"), "Erreurs dans les champs", Alert.OK);
		} else {
			scene.ajouter.ajouter_btn.enabled = false;
			envoiMess = new LoadVars();
			envoiMess.titre = scene.ajouter.titre.text;
			envoiMess.pseudo = scene.ajouter.pseudo.text;
			envoiMess.mail = scene.ajouter.mail.text;
			envoiMess.msg = scene.ajouter.msg.text;
			envoiMess.sendAndLoad("ajoutLivre.php", envoiMess, "POST");
			// Ici on dit que notre onLoad sera la fonction envoiLoad
			//		de notre objet Param, via Delegate.create
			envoiMess.onLoad = Delegate.create(this, envoiLoad);
		}
	}
	private function envoiLoad(succes:Boolean):Void {
		if (succes) {
			if (envoiMess.res=0) {
				scene.ajouter.ajouter_btn.enabled = true;
				Alert.show(envoiMess.erreur, "Erreurs PHP", Alert.OK);
			} else {
				// Le message a bien été envoyé, on réaffiche le Livre en commençant à 0
				pageAct = 0;
				actionBout();
			}
		} else {
			trace("Erreur d'envoi du message");
		}
	}
}
